"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _CreateDatabase = _interopRequireDefault(require("../model/CreateDatabase"));
var _DatabaseSchema = _interopRequireDefault(require("../model/DatabaseSchema"));
var _InlineResponse = _interopRequireDefault(require("../model/InlineResponse202"));
var _InlineResponse2 = _interopRequireDefault(require("../model/InlineResponse400"));
var _InlineResponse3 = _interopRequireDefault(require("../model/InlineResponse403"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/**
 * OFDB API
 * OFDB API
 *
 * The version of the OpenAPI document: 2.1.0
 * Contact: api@factset.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

/**
* Create service.
* @module api/CreateApi
*/
class CreateApi {
  /**
  * Constructs a new CreateApi. 
  * @alias module:api/CreateApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  constructor(apiClient) {
    this.apiClient = apiClient || _ApiClient.default.instance;
  }

  /**
   * Creates a 2d or 3d database(OFDB). Users will note that not every field requires all the parameters listed in the schema. Please review FactSet data types on the OA for further guidance.
   * @param {Object} opts Optional parameters
   * @param {module:model/DatabaseSchema} opts.databaseSchema 
   * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CreateDatabase} and HTTP response
   */
  createDatabaseWithHttpInfo(opts) {
    opts = opts || {};
    let postBody = opts['databaseSchema'];
    let pathParams = {};
    let queryParams = {};
    let headerParams = {};
    let formParams = {};
    let authNames = ['FactSetApiKey', 'FactSetOAuth2'];
    let contentTypes = ['application/json'];
    let accepts = ['application/json'];
    let returnType = _CreateDatabase.default;
    return this.apiClient.callApi('/database', 'POST', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null);
  }

  /**
   * Creates a 2d or 3d database(OFDB). Users will note that not every field requires all the parameters listed in the schema. Please review FactSet data types on the OA for further guidance.
   * @param {Object} opts Optional parameters
   * @param {module:model/DatabaseSchema} opts.databaseSchema 
   * @return { Promise.< module:model/CreateDatabase > } a Promise, with data of type {@link module:model/CreateDatabase }
   */
  createDatabase(opts) {
    return this.createDatabaseWithHttpInfo(opts).then(function (response_and_data) {
      return response_and_data.data;
    });
  }
}
exports.default = CreateApi;